---

default:
  image: registry.gitlab.com/prologin/tech/infra/infrastructure:latest
variables:
  VAULT_ADDR: https://vault.prologin.dev

stages:
  - build
  - test
  - lint
  - qa
  - doc
  - deploy

docker-build:
  stage: build
  image:
    name: moby/buildkit:latest
    entrypoint: [""]
  before_script:
    - mkdir ~/.docker
    - echo "{\"auths\":{\"$CI_REGISTRY\":{\"username\":\"$CI_REGISTRY_USER\",\"password\":\"$CI_REGISTRY_PASSWORD\"}}}" > ~/.docker/config.json
  script:
    - |
      buildctl-daemonless.sh build --progress=plain \
          --frontend=dockerfile.v0 \
          --local context=. \
          --local dockerfile=. \
          --output type=image,\"name=$CI_REGISTRY_IMAGE:$CI_COMMIT_SHA,$CI_REGISTRY_IMAGE:latest\",push=true \
          --import-cache type=registry,ref=$CI_REGISTRY_IMAGE:buildcache \
          --export-cache type=registry,ref=$CI_REGISTRY_IMAGE:buildcache,mode=max

ansible-lint:
  stage: lint
  needs: []
  # TODO: fix this
  allow_failure: true
  variables:
    ANSIBLE_CONFIG: ansible.cfg
  script: |
    ansible-lint --skip-list yaml --parseable --config-file ./.ansible-lint --project-dir .

pre-commit:
  stage: lint
  needs: []
  # TODO: fix this
  allow_failure: true
  before_script:
    - >
      echo '{"root_token": ""}' > vault/bootstrap/secrets/vault.json
  script:
    - pre-commit run --all-files

doc:
  stage: doc
  needs: []
  script:
    - mdbook build
  artifacts:
    paths:
      - book/html
    expire_in: 1 week

pages:
  stage: deploy
  needs:
    - doc
  script:
    - cp -r book/html public
  artifacts:
    paths:
      - public
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
